fzu 2277 Change 线段树

2024-09-09 06:48
文章标签 change 线段 fzu 2277

本文主要是介绍fzu 2277 Change 线段树,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

Problem 2277 Change

Time Limit: 2000 mSec    Memory Limit : 262144 KB

 Problem Description

There is a rooted tree with n nodes, number from 1-n. Root’s number is 1.Each node has a value ai.

Initially all the node’s value is 0.

We have q operations. There are two kinds of operations.

1 v x k : a[v]+=x , a[v’]+=x-k (v’ is child of v) , a[v’’]+=x-2*k (v’’ is child of v’) and so on.

2 v : Output a[v] mod 1000000007(10^9 + 7).

 Input

First line contains an integer T (1 ≤ T ≤ 3), represents there are T test cases.

In each test case:

The first line contains a number n.

The second line contains n-1 number, p2,p3,…,pn . pi is the father of i.

The third line contains a number q.

Next q lines, each line contains an operation. (“1 v x k” or “2 v”)

1 ≤ n ≤ 3*10^5

1 ≤ pi < i

1 ≤ q ≤ 3*10^5

1 ≤ v ≤ n; 0 ≤ x < 10^9 + 7; 0 ≤ k < 10^9 + 7

 Output

For each operation 2, outputs the answer.

 Sample Input

131 131 1 2 12 12 2

 Sample Output

21

 Source

第八届福建省大学生程序设计竞赛-重现赛(感谢承办方厦门理工学院)

对于u的子树所在节点v(含u)
对v的影响为+  :    
x - (deep[v]-deep[u])*k
= x + deep[u]*k - deep[v]*k
分成两部分: 
Add:   x + deep[u]*k  , 区间更新
Sub: deep[v]*k , 区间更新,  deep[v]最后再乘
import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;public class Main {public static void main(String[] args) {new Task().solve();}
}class Task {InputReader in = new InputReader(System.in) ;PrintWriter out = new PrintWriter(System.out) ;final long Mod = 1000000007L ;List<Integer>[] adj ; int[] left , right  , deep ;int time ;void dfs(int u , int dep){left[u] = ++time ;deep[u] = dep ;for(int v : adj[u]){dfs(v , dep+1) ;}right[u] = time ;}long[] add , addSum , sub , subSum ;void down(int t){if(add[t] != 0){add[t<<1] += add[t] ;add[t<<1] %= Mod ;add[t<<1|1] += add[t] ;add[t<<1|1] %= Mod ;addSum[t<<1] += add[t] ;addSum[t<<1] %= Mod ;addSum[t<<1|1] += add[t] ;addSum[t<<1|1] %= Mod ;add[t] = 0 ;}if(sub[t] != 0){sub[t<<1] += sub[t] ;sub[t<<1] %= Mod ;sub[t<<1|1] += sub[t] ;sub[t<<1|1] %= Mod ;subSum[t<<1] += sub[t] ;subSum[t<<1] %= Mod ;subSum[t<<1|1] += sub[t] ;subSum[t<<1|1] %= Mod ;sub[t] = 0 ;}}void update(int L , int R , long toAdd , long toSub , int l , int r , int t){if(L <= l && r <= R){add[t] += toAdd ;add[t] %= Mod ;addSum[t] += toAdd ;addSum[t] %= Mod ;sub[t] += toSub ;sub[t] %= Mod ;subSum[t] += toSub ;subSum[t] %= Mod ;return ;}down(t) ;int m = (l + r) >> 1 ;if(L <= m){update(L, R, toAdd, toSub, l, m, t<<1) ;}if(R > m){update(L, R, toAdd, toSub, m+1, r, t<<1|1) ;}}long query(int i , int l , int r , int t , int dep){if(l == r){long reslut = addSum[t] - subSum[t] * dep % Mod ;reslut %= Mod ;reslut = (reslut + Mod) % Mod ;return reslut ;}down(t) ;int m = (l + r) >> 1 ;if(i <= m){return query(i, l, m, t<<1 , dep) ;}else{return query(i, m+1, r, t<<1|1, dep) ;}}void solve(){int t = in.nextInt() ;while(t-- > 0){int n = in.nextInt() ;adj = new List[n+1] ;for(int i = 1 ; i <= n ; i++){adj[i] = new ArrayList<Integer>() ;}for(int i = 2 ; i <= n ; i++){adj[in.nextInt()].add(i) ;}left = new int[n+1] ;right = new int[n+1] ;deep = new int[n+1] ;add = new long[n<<2] ;addSum = new long[n<<2] ;sub = new long[n<<2] ;subSum = new long[n<<2] ;Arrays.fill(add, 0); Arrays.fill(addSum, 0); Arrays.fill(sub , 0); Arrays.fill(subSum , 0); time = 0 ; dfs(1 , 0) ;int q = in.nextInt() ;while(q-- > 0){if(in.nextInt() == 1){int u = in.nextInt() ;long x = in.nextLong() ;long k = in.nextLong() ;update(left[u] , right[u] , (x + deep[u] * k % Mod) % Mod, k, 1, n, 1) ;}else{int v = in.nextInt() ;out.println(query(left[v] , 1 , n , 1 , deep[v])) ;}}}  out.flush() ;}
}class InputReader {    public BufferedReader reader;    public StringTokenizer tokenizer;    public InputReader(InputStream stream) {    reader = new BufferedReader(new InputStreamReader(stream), 32768);    tokenizer = new StringTokenizer("");    }    private void eat(String s) {    tokenizer = new StringTokenizer(s);    }    public String nextLine() {     try {    return reader.readLine();    } catch (Exception e) {    return null;    }    }    public boolean hasNext() {    while (!tokenizer.hasMoreTokens()) {    String s = nextLine();    if (s == null)    return false;    eat(s);    }    return true;    }    public String next() {    hasNext();    return tokenizer.nextToken();    }    public int nextInt() {    return Integer.parseInt(next());    }    public int[] nextInts(int n) {    int[] nums = new int[n];    for (int i = 0; i < n; i++) {    nums[i] = nextInt();    }    return nums;    }    public long nextLong() {    return Long.parseLong(next());    }    public double nextDouble() {    return Double.parseDouble(next());    }    public BigInteger nextBigInteger() {    return new BigInteger(next());    }    }    




这篇关于fzu 2277 Change 线段树的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1150454

相关文章

poj3468(线段树成段更新模板题)

题意:包括两个操作:1、将[a.b]上的数字加上v;2、查询区间[a,b]上的和 下面的介绍是下解题思路: 首先介绍  lazy-tag思想:用一个变量记录每一个线段树节点的变化值,当这部分线段的一致性被破坏我们就将这个变化值传递给子区间,大大增加了线段树的效率。 比如现在需要对[a,b]区间值进行加c操作,那么就从根节点[1,n]开始调用update函数进行操作,如果刚好执行到一个子节点,

hdu1394(线段树点更新的应用)

题意:求一个序列经过一定的操作得到的序列的最小逆序数 这题会用到逆序数的一个性质,在0到n-1这些数字组成的乱序排列,将第一个数字A移到最后一位,得到的逆序数为res-a+(n-a-1) 知道上面的知识点后,可以用暴力来解 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#in

hdu1689(线段树成段更新)

两种操作:1、set区间[a,b]上数字为v;2、查询[ 1 , n ]上的sum 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdl

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

poj 1127 线段相交的判定

题意: 有n根木棍,每根的端点坐标分别是 px, py, qx, qy。 判断每对木棍是否相连,当他们之间有公共点时,就认为他们相连。 并且通过相连的木棍相连的木棍也是相连的。 解析: 线段相交的判定。 首先,模板中的线段相交是不判端点的,所以要加一个端点在直线上的判定; 然后,端点在直线上的判定这个函数是不判定两个端点是同一个端点的情况的,所以要加是否端点相等的判断。 最后

HDU4737线段树

题目大意:给定一系列数,F(i,j)表示对从ai到aj连续求或运算,(i<=j)求F(i,j)<=m的总数。 const int Max_N = 100008 ;int sum[Max_N<<2] , x[Max_N] ;int n , m ;void push_up(int t){sum[t] = sum[t<<1] | sum[t<<1|1] ;}void upd

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;

圆与线段的交点

poj 3819  给出一条线段的两个端点,再给出n个圆,求出这条线段被所有圆覆盖的部分占了整条线段的百分比。 圆与线段的交点 : 向量AB 的参数方程  P = A + t * (B - A)      0<=t<=1 ; 将点带入圆的方程即可。  注意: 有交点 0 <= t <= 1 ; 此题求覆盖的部分。 则 若求得 t  满足 ; double ask(d

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja